window.onload = function() {
	window.requestAnimFrame = (function() {   //анимация
      return window.requestAnimationFrame ||
         window.webkitRequestAnimationFrame ||
         window.mozRequestAnimationFrame ||
         function(callback) {                     //функция, задающая шаг по времени для обновления картинки на экране
            window.setTimeout(callback, 1000 / 60);
         };
   })();
   
   
   var с = document.getElementById("c");
   var ctx = c.getContext("2d");     // на context происходит рисовани
   
   var amount_of_particles = 1000; //количество генерируемых частиц
   var massiv = []; //массив, хранящий параметры частиц
   
   var particles = function(x, y, r, color, angle, orbitRadius, angularSpeed, randomSpeed0, acceleration) {   //функция,задающая переменные для параметров частиц
      this.x = x; //координата по оси Ох
      this.y = y; //координата по оси Оу
      this.r = r; //радиус
      this.color = color; //цвет
      this.angle = angle; //угол вылета
      this.orbitRadius = orbitRadius; //радиус изначальной орбиты
      this.angularSpeed = angularSpeed; //угловая скорость
      this.randomSpeed0 = randomSpeed0; //скорость частицы (задается рандомно)
      this.acceleration = acceleration; //ускорение
   };

   function makeParticles(new_particles) {   //функция для создания гравитационной точки
      var x, y, r, color, angle, orbitRadius, angularSpeed, randomSpeed0, acceleration; //вызываем переменные

      x = с.width/2; //координата по оси Ох
      y = с.height/2; //координата по оси Оу
      r = Math.random() * 2 + .5; //рандомное задание радиуса частицы
      color = "rgba(254,254,254,1)"; //задание цвет
      angle = Math.random() * (2 * Math.PI); //рандомное задание угла
      orbitRadius = (Math.random() * (с.width + с.height))/3;  //рандомное задание радиуса орбиты 
      angularSpeed = .3 * Math.random() * (Math.PI / orbitRadius);  //рандомное задание угловой скорости
      randomSpeed0 = Math.random() * (Math.PI / (10 * orbitRadius)); //рандомное задание скорости
      acceleration = 0; //обнуление ускорения (изначально частицы не имеют ускорения)
	   
      massiv.push(   //добавляем в массив созданную частицу
         new particles(x, y, r, color, angle, orbitRadius, angularSpeed, randomSpeed0, acceleration)
      );
   }

   function add_new_particles() {  //цикл, создающий заданное количество частиц
      for (var i = 0; i < amount_of_particles; i++) {
         makeParticles(0);
      }
   }
   
   function drawG_Point() {  //рисование гравитационной точки
      ctx.fillStyle = "rgb(0,0,0)"; //цвет
      ctx.shadowColor = "rgba(255,255,255,.3)"; //цвет тени
	  ctx.shadowBlur = .5*G_Point_Radius.value; //размер перехода

      ctx.beginPath(); 
      ctx.arc(с.width/2, с.height/2, G_Point_Radius.value, 0, 2 * Math.PI);
      ctx.closePath(); 
      ctx.fill();
      ctx.shadowBlur = 0; 
   }

   function updateParticles(i) {  //обновляем 
      var particles = massiv[i];

      particles.x = с.width / 2 + Math.cos(particles.angle) * particles.orbitRadius; //изменение координаты по оси Ох
      particles.y = с.height / 2 + Math.sin(particles.angle) * particles.orbitRadius; //изменение координаты по оси Оу
      particles.angle += particles.angularSpeed; //изменение угла
      particles.acceleration = Gravity.value * (particles.r * hole_volume) / Math.pow(particles.orbitRadius, 2) + 0.1; //увеличение ускорения
      particles.color = "rgba(113," + Math.round(278 * ((particles.orbitRadius - G_Point_Radius.value) / 200)) + "," + Math.round(359 * ((particles.orbitRadius - G_Point_Radius.value) / 200)) + ",1)";

      if (particles.orbitRadius >= G_Point_Radius.value) {  //изменение радиуса орбиты частицы
         particles.orbitRadius -= particles.acceleration;
      } else {
         massiv.splice(i,1); //функция для слияния частиц с гравитационной точкой
         makeParticles(1); //функция, отвечающая за создание новых частиц
      }
   }

   function isVisible(particles) {  //функция, убирающая точки при их касании гравитационной точки
      if (particles.x > с.width || particles.x + particles.r < 0 || particles.y > с.height || particles.y + particles.r < 0)
         return false;
      return true;
   }

   function drawParticles(particles) {  //рисование частиц
      ctx.fillStyle = particles.color;
      ctx.beginPath();
      ctx.fillRect(particles.x, particles.y, particles.r, particles.r);
      ctx.fill();
   }

   function start_program() {  //функция, отвечающая за работу программы
      ctx.fillStyle = "rgba(20,20,24,.2)"; //закрашивание поля 
      ctx.fillRect(0, 0, с.width, с.height);
      var particles;  //вызов функции для создания частиц

      hole_volume = (3 / 4) * Math.PI * Math.pow(G_Point_Radius.value, 3); //создание "объемности" для гравитационной точки
      for (var i = 0; i < massiv.length; i++) { //создание массива частиц
         particles = massiv[i];
         
		 if (isVisible(particles)) drawParticles(particles); //обновление параметров частиц под воздействием гравитации
        	updateParticles(i);
      }
	  
      drawG_Point(); 
      requestAnimFrame(start_program);
   }
   
   add_new_particles(); //вызов функции генерации частиц
   start_program(); //запуск программы

}
   